【C+学习笔记】C+异常处理!你绝对不能错过的干货!

合理地使用C++异常处理,能够使我们写出来的程序更加稳定强健,不易崩溃。那么,应该如何使用C++异常处理呢?下面,我们就来向大家介绍最简单也是最常用的异常处理语句 。

一、什么是异常

用官方的话来说就是程序在执行过程中产生的问题,换句通俗的话来讲就是程序执行的出现的异常,比如程序崩了、内存泄漏了、数组越界以及其他异常信息的出现。

常提供了一种转移程序控制权的方式。C++ 异常处理涉及到三个关键字:try、catch、throw。

throw: 当问题出现时,程序会抛出一个异常。这是通过使用 throw 关键字来完成的。

catch: 在您想要处理问题的地方,通过异常处理程序捕获异常。catch 关键字用于捕获异常。

try: try 块中的代码标识将被激活的特定异常。它后面通常跟着一个或多个 catch 块。

如果有一个块抛出一个异常,捕获异常的方法会使用 try 和 catch 关键字。try 块中放置可能抛出异常的代码,try 块中的代码被称为保护代码。使用 try/catch 语句的语法如下所示:

try

{

// 保护代码

}catch( ExceptionName e1 )

{

// catch 块

}catch( ExceptionName e2 )

{

// catch 块

}catch( ExceptionName eN )

{

// catch 块

}

如果 try 块在不同的情境下会抛出不同的异常,这个时候可以尝试罗列多个 catch 语句,用于捕获不同类型的异常。

二、抛出异常

您可以使用 throw 语句在代码块中的任何地方抛出异常。throw 语句的操作数可以是任意的表达式,表达式的结果的类型决定了抛出的异常的类型。

以下是尝试除以零时抛出异常的实例:

double division(int a, int b)

{

if( b == 0 )

{

    throw "Division by zero condition!";

}

return (a/b);

}

三、捕获异常

catch 块跟在 try 块后面,用于捕获异常。您可以指定想要捕捉的异常类型,这是由 catch 关键字后的括号内的异常声明决定的。

try

{

// 保护代码

}catch( ExceptionName e )

{

// 处理 ExceptionName 异常的代码

}

上面的代码会捕获一个类型为 ExceptionName 的异常。如果您想让 catch 块能够处理 try 块抛出的任何类型的异常,则必须在异常声明的括号内使用省略号 ...,如下所示:

try

{

// 保护代码

}catch(...)

{

// 能处理任何异常的代码

}

下面是一个实例,抛出一个除以零的异常,并在 catch 块中捕获该异常。

#include

using namespace std;

double division(int a, int b)

{

if( b == 0 )

{

    throw "Division by zero condition!";

}

return (a/b);

}

int main ()

{

int x = 50;

int y = 0;

double z = 0;

try {

  z = division(x, y);

  cout

}catch (const char* msg) {

  cerr

}

return 0;

}

由于我们抛出了一个类型为 const char* 的异常,因此,当捕获该异常时,我们必须在 catch 块中使用 const char*。当上面的代码被编译和执行时,它会产生下列结果:

Division by zero condition!

四、异常的处理规则

throw抛出的异常类型与catch抓取的异常类型要一致;

throw抛出的异常类型可以是子类对象,catch可以是父类对象;

catch块的参数推荐采用地址传递而不是值传递,不仅可以提高效率,还可以利用对象的多态性。另外,派生类的异常捕获要放到父类异常扑获的前面,否则,派生类的异常无法被扑获;

如果使用catch参数中,使用基类捕获派生类对象,一定要使用传递引用的方式,例如catch (exception &e);

异常是通过抛出对象而引发的,该对象的类型决定了应该激活哪个处理代码;

被选中的处理代码是调用链中与该对象类型匹配且离抛出异常位置最近的那一个;

在try的语句块内声明的变量在外部是不可以访问的,即使是在catch子句内也不可以访问;

栈展开会沿着嵌套函数的调用链不断查找,直到找到了已抛出的异常匹配的catch子句。如果抛出的异常一直没有函数捕获(catch),则会一直上传到c++运行系统那里,导致整个程序的终止。

五、C++ 标准的异常

C++ 提供了一系列标准的异常,定义在  中,我们可以在程序中使用这些标准的异常。它们是以父子类层次结构组织起来的,如下所示:

下表是对上面层次结构中出现的每个异常的说明:

异常描述

六、定义新的异常

您可以通过继承和重载 exception 类来定义新的异常。下面的实例演示了如何使用 std::exception 类来实现自己的异常:

实例

#include #include using namespace std;

struct MyException : public exception{  const char * what () const throw ()  {    return "C++ Exception";

}};

int main(){  try  {    throw MyException();

}  catch(MyException& e)  {    std::cout

  std::cout

}  catch(std::exception& e)  {    //其他的错误  }}

这将产生以下结果:

MyException caught

C++ Exception

在这里,what() 是异常类提供的一个公共方法,它已被所有子异常类重载。这将返回异常产生的原因。

七、总结

1. 使用异常处理的优点:

传统错误处理技术,检查到一个错误,只会返回退出码或者终止程序等等,我们只知道有错误,但不能更清楚知道是哪种错误。使用异常,把错误和处理分开来,由库函数抛出异常,由调用者捕获这个异常,调用者就可以知道程序函数库调用出现的错误是什么错误,并去处理,而是否终止程序就把握在调用者手里了。

2. 使用异常的缺点:

如果使用异常,光凭查看代码是很难评估程序的控制流:函数返回点可能在你意料之外,这就导致了代码管理和调试的困难。启动异常使得生成的二进制文件体积变大,延长了编译时间,还可能会增加地址空间的压力。

C++没有垃圾回收机制,资源需要自己管理。有了异常非常容易导致内存泄漏、死锁等异常安全问题。 这个需要使用RAII来处理资源的管理问题。学习成本较高。

C++标准库的异常体系定义得不好,导致大家各自定义各自的异常体系,非常的混乱。

3. 什么时候使用异常?

建议:除非已有的项目或底层库中使用了异常,要不然尽量不要使用异常,虽然提供了方便,但是开销也大。

4. 程序所有的异常都可以catch到吗?

并非如此,只有发生异常,并且又抛出异常的情况才能被 catch 到。例如,数组下标访问越界的情况,系统是不会自身抛出异常的,所以我们无论怎么 catch 都是无效的;在这种情况,我们需要自定义抛出类型,判断数组下标是否越界,然后再根据自身需要throw自定义异常对象,这样才可以catch到异常,并进行进一步处理。

看到这里你是不是对“C++”又有了一点新的认知呢~

如果你喜欢这篇文章的话,动动小指,加个关注哦~

  • 发表于:
  • 原文链接https://kuaibao.qq.com/s/20201030A07F4900?refer=cp_1026
  • 腾讯「腾讯云开发者社区」是腾讯内容开放平台帐号(企鹅号)传播渠道之一,根据《腾讯内容开放平台服务协议》转载发布内容。
  • 如有侵权,请联系 cloudcommunity@tencent.com 删除。

扫码关注腾讯云开发者

领取腾讯云代金券